mod Mprt

incl Mtex

incl Mtexpr

incl Mprf

rem 
  \para \bf  Arithmetization of primitive recursive terms.  \end 

fun Vt 'Tex_f1_pr_vt'
  Vt(i) = 0,i

fun Ct 'Tex_f1_pr_ct'
  Ct(m) = 1,m

fun/2 Pt 'Tex_f2_pr_pt'
  Pt(t,ts) = 2,t,ts

fun/2 At 'Tex_f2_pr_at'
  At(f,ts) = 3,f,ts

rem 
  \para \bf  Codes of primitive recursive terms.  \end \header* pred/2 Prt  \end 
  The predicate \ft Prt(t,n) \end holds if the number \ft t \end is the code of 
  some p.r. term containing only variables 
  \ft x1,Texm_f0_dotsc,Texm_f2_sub(x,n) \end. 

pred/3 Prt1 
  Prt1(k,Vt(i),n) <- k = 1 & 1 <= i & i <= n
  Prt1(k,Ct(m),n) <- k = 1
  Prt1(k,Pt(t,ts),n) <- k > 1 & Prt1(1,t,n) & Prt1(k-1,ts,n)
  Prt1(k,At(f,ts),n) <- k = 1 & Prf(f) & Prt1(Ar(f),ts,n)

pred/2 Prt 
  Prt(t,n) <-> Prt1(1,t,n)

rem 
  \para \bf  [CL] Display of the codes of primitive recursive terms.  \end The 
  unary predicate \ft Ft \end is the union format and it can be used to control 
  the display of the codes of p.r. terms. 

pred Ft 
  Ft Vt(i) <- N(i)
  Ft Ct(m) <- N(m)
  Ft Pt(t,ts) <- Ft(t) & Ft(ts)
  Ft At(f,ts) <- Ff(f) & Ft(ts)

